/**
	Haed a free program maker and generator
	Copyright (C) 2018  Florian Evaldsson

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
/**
	Haed a free program maker and generator
	Copyright (C) 2018  Florian Evaldsson

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include "includes.h"

/**
	Add all objects visually to the different areas in the current ''level''?
	
	@todo
		move this elsewhere?

	@param programParent
		programparent to read from
*/
void haed_visual_add_all_objects(EksParent *programParent)
{
	EksParent *objectsParent=eks_parent_get_child_from_name(programParent,"objects");
	EksParent *activeParent=eks_parent_get_child_from_name(objectsParent,"active");
	
	eks_parent_foreach_child_start(activeParent,loopUnit)
	{
		if(eks_parent_compare_type(loopUnit,EKS_PARENT_TYPE_VALUE))
		{
			haed_trigghandler_add_object(loopUnit);
			haed_object_set_level_editor_icons(loopUnit);
			haed_object_set_trigger_icons(loopUnit);
		}
	}eks_parent_foreach_child_end(activeParent,loopUnit);
}

//move this elsewhere?
void haed_visual_clean_other(void)
{
	
}

/**
	Get file contents from zipfile.
	
	@todo 
		move this function elsewhere?
		
	@param filename
		
*/
char *zip_get_file_contents(char *filename,struct zip *z,struct zip_stat *st,int *contentsLength) 
{
	struct zip_file *f;
	char *contents;
	
	if(zip_stat(z, filename, 0, st)==-1)
	{
		b_error_message("Could not initzialize the file length!");
		return NULL;
	}
	
	//Alloc memory for its uncompressed contents
	contents = calloc(st->size+1,sizeof(char));
	
	//Read the compressed file
	if(!(f = zip_fopen(z, filename, 0)))
	{
		b_error_message("Could not open the inner file!");
		return NULL;
	}
	
	//läs in filinehållet i strängen.
	zip_fread(f, contents, st->size);
	
	if(contentsLength)
		*contentsLength=st->size;
	
	zip_fclose(f);
	
	return contents;
}

/**
	Used by lexca to extract a list of objects found
	
	@param str
		used from function
	@param type
		type returned
	@param inparam
		a structure list, see below
*/
void haed_eks_lexca_get_unit_data(const char *str,LexcaStrType type,void **inparam)
{
	intptr_t pos=(intptr_t)inparam[0];

	if(type==LEXCA_TYPE_IDENTIFIER)
	{
		inparam[pos]=g_strdup(str);
		
		inparam[0]=(void*)(pos+1);
	}
}

/**
	Load triggers from a parent structure. This will load all triggers, and add them to the global structure.

	@param program
		the parent structure to load from
*/
void haed_eks_set_triggers_from_parent(EksParent *program)
{
	b_tm("%s",eks_parent_dump_text(program));
	EksParent *curLevel=haed_programinfo_get_current_level(program);

	EksParent *mapConditions=eks_parent_get_child_from_name(curLevel,"triggers");

	TriggerHandler *thishandler=HAED_GLOBAL_TRIGGER_HANDLER;

	if(!(mapConditions && thishandler))
	{
		b_error_message("no map conditions or triggers to modify!");
		return;
	}
	
	b_tm("GETTING TRIGGERS! %ld %s",eks_parent_get_child_amount(mapConditions),eks_parent_dump_text(curLevel));

	for(int i=0;i<eks_parent_get_child_amount(mapConditions);i++)
	{
		EksParent *conditionEksParent=eks_parent_get_child(mapConditions,i);
		
		b_tm("thisname: %s\n",conditionEksParent->name);

		EksParent *condition=conditionEksParent;
		haed_triggers_insert_row(HAED_GLOBAL_TRIGGER_GRID,condition);

		//for setting the buttons correctly
		//go through all condition actions
		for(int j=0;j<eks_parent_get_child_amount(conditionEksParent);j++)
		{
			char *actionString=eks_parent_get_string(eks_parent_get_child(conditionEksParent,j));
			
			b_tm("actionString: %s",actionString);
			
			//
			void *inout[]={1,NULL,NULL};
			
			lexca_for_each(actionString,haed_eks_lexca_get_unit_data,inout);
			
			//should get a list of objects
			char *firstFunctionName=inout[1];
			char *unitListString=inout[2];

			//to find the object
			for(int k=0;k<thishandler->columnAmount;k++)
			{
				EksParent *theObject=thishandler->objects[k];
				
				if(theObject)
				{
					if(strcmp(theObject->upperEksParent->name,ACTIVE_OBJECT_S)==0)
					{
						//if it found the object
						if(strcmp(theObject->name,unitListString)==0)
						{
							haed_triggers_add_visual_for_action(thishandler->row[thishandler->rowAmount-1]->ActionButtons[k],actionString);
						}
					}
					else if(strcmp(theObject->name,TRIGGERS_STORY_S)==0 && strcmp(firstFunctionName,"SET_LEVEL")==0)
					{
						haed_triggers_add_visual_for_action(thishandler->row[thishandler->rowAmount-1]->ActionButtons[k],actionString);
					}
				}
			}
		}
	}
}

/**
	Set all units from a eksparent structure, used in loadgame
	on a save-file the aoparent should be the one with Active-object as the name

	@param rootParent
		the input parent object wich will set all objects after its structure.
*/
void haed_eks_set_objects_from_parent(EksParent *rootParent)
{
	EksParent *objectsParent=eks_parent_get_child_from_name(rootParent,"objects");
	EksParent *AOEksParent=eks_parent_get_child_from_name(objectsParent,"active");
	EksParent *levelsParent=eks_parent_get_child_from_name(rootParent,"levels");
	EksParent *currLevelParent=eks_parent_get_child_from_type(levelsParent,0,EKS_PARENT_TYPE_VALUE);
	
	haed_programinfo_set_current_level(rootParent,currLevelParent);
	
	TriggerHandler *thandler=calloc(1,sizeof(TriggerHandler));
	eks_parent_custom_set(currLevelParent,thandler,0);
	
	g_message("erp");

	eks_parent_foreach_child_start(levelsParent,thisLevel)
	{
		if(eks_parent_compare_type(thisLevel,EKS_PARENT_TYPE_VALUE))
		{
			EksParent *positionsParent=eks_parent_get_child_from_name(thisLevel,"positions");
		
			eks_parent_foreach_child_start(positionsParent,loopUnit)
			{
				b_tm("erp2");
				if(eks_parent_compare_type(loopUnit,EKS_PARENT_TYPE_VALUE))
				{
					eks_parent_foreach_child_start(AOEksParent,loopObject)
					{
						b_tm("erp3");
						if(eks_parent_compare_type(loopObject,EKS_PARENT_TYPE_VALUE))
						{
							b_tm("obj1 %s obj2 %s",loopUnit->name,loopObject->name);
				
							if(strcmp(loopUnit->name,loopObject->name)==0)
							{
								eks_parent_custom_set(loopUnit,loopObject,0);
							}
						}
					}eks_parent_foreach_child_end(AOEksParent,loopObject);
				}
			}eks_parent_foreach_child_end(positionsParent,loopUnit);
		}
	}	eks_parent_foreach_child_end(levelsParent,thisLevel);
}

/**
	Load a program from a hft file aka zip-file.
	
	@param filename
		the path to the hft file.
	@returns
		1 if the function exited correctly.
*/
int haed_open_filetype_hft(char *filename)
{
	//Open the ZIP archive
	int err = 0;
	const char *name;
	struct zip *z;
	struct zip_stat *st;
	struct zip_file *f;
	char *contents;
	char *contents2;
	
	EksParent *gameEksParent=NULL;
	
	haed_triggers_visual_reset();
	
	z = zip_open(filename, 0, &err);
	
	//om du lnyckades att öppna filen.
	if(z!=NULL)
	{
		//Search for the file of given nam
		st=calloc(1,sizeof(struct zip_stat));
		
		zip_stat_init(st);
		
		if(zip_stat(z, "program.eks", 0, st)==-1)
		{
			b_error_message("Could not find the file: program.eks!");
			return 0;
		}
		
		contents = calloc(st->size+1,sizeof(char));
		
		f = zip_fopen(z, "program.eks", 0);
		
		zip_fread(f, contents, st->size);
		
		gameEksParent=eks_parent_parse_text((unsigned char*)contents,"Program");
		
		haed_eks_set_objects_from_parent(gameEksParent);
		
		b_tm("%s",eks_parent_dump_text(gameEksParent));
		
		free(contents);
		
		//read other
		
		int numberofzipentries=zip_get_num_entries(z,ZIP_FL_UNCHANGED);
		
		//för varje fil i zipfilen
		for(int i=0;i<numberofzipentries;i++)
		{
			//namnet av filen
			name= zip_get_name(z, i, err);
			
			b_tm("filename: %s\n",name);
			
			//Är en fil && har mapp-namnet "customXml" ||  "docProps"
			if(name[strlen(name)-1]!='/')
			{
				int explode_ln=0;
				char **explodedName=b_explode((char*)name,&explode_ln,"/");
				
				if(explode_ln==3 && strcmp(explodedName[0],"img")==0 && strcmp("inf.eks",explodedName[2])==0)
				{
					//=====image file======
					b_tm("filnamn: %s",name);

					//======eks file====
					char *eksfilename=concat(explodedName[0],"/",explodedName[1],"/inf.eks",NULL);

					contents2=zip_get_file_contents(eksfilename,z,st,NULL);
					
					//printf("EKSFILENAME: %s\n%d\n",contents2,imageBufferLen);

					EksParent *bufholderParent=eks_parent_parse_text((unsigned char*)contents2,"inf");
					
					//get all image files and read them into the pix buffer
					for(int iii=0;iii<numberofzipentries;iii++)
					{
						const char *name2= zip_get_name(z, iii, err);
						
						if(name2[strlen(name2)-1]!='/')
						{
							int explode_ln2=0;
							char **explodedName2=b_explode((char*)name2,&explode_ln2,"/");
							
							const char *imagefilename=NULL;
							
							for(int ii=0;ii<GLOBAL_ANIMATION_VECTOR_LEN;ii++)
							{
								char *tempname=concat(GLOBAL_ANIMATION_VECTOR[ii],".png",NULL);
								
								if(explode_ln2 ==3 && strcmp(explodedName[1],explodedName2[1])==0 && strcmp(explodedName2[2],tempname)==0)
								{
									imagefilename=GLOBAL_ANIMATION_VECTOR[ii];
									
									b_tm("ANIMATION: %s\n",imagefilename);
									
									int imageBufferLen;
									//Alloc memory for its uncompressed contents
									contents = zip_get_file_contents((char*)name2,z,st,&imageBufferLen);
									
									GdkPixbufLoader *testLoader=gdk_pixbuf_loader_new_with_type("png",NULL);
									gdk_pixbuf_loader_write(testLoader,(const unsigned char *)contents,imageBufferLen,NULL);
									
									haed_pixbufholder_set_animation_from_pixbuf(bufholderParent,(char*)imagefilename,gdk_pixbuf_loader_get_pixbuf(testLoader));
									
									free(contents);
								}
								free(tempname);
							}
						}
					}
					
					haed_pixbufholder_fix_object(bufholderParent,explodedName[1],gameEksParent);
					
					printf("RIGHTY DONE\n");
					//GdkPixbufLoader *testLoader=gdk_pixbuf_loader_new_with_type("png",NULL);
					//gdk_pixbuf_loader_write(testLoader,contents,imageBufferLen,NULL);
					
					//haed_pixbufholder_add_animation_from_pixbuf(bufholderParent,(char*)imagefilename,gdk_pixbuf_loader_get_pixbuf(testLoader));
					
					//AddEksParentGUI(explodedName[1],bufholderParent,ACTIVE_OBJECT_S);
					
					free(contents2);
				}
			}
		}
		
		haed_eks_set_triggers_from_parent(gameEksParent);
		
		//b_tm("→→→%s\n%d\n%d",contents,strlen(contents),st->size);
		
		zip_fclose(f);
		
		//And close the archive
		zip_close(z);
		
		HAED_GLOBAL_INFORMATION.firstProgram->program=gameEksParent;
	}
	
	haed_storyboard_visual_reset(gameEksParent);
	
	b_tm("DONE LOADING!");
	
	return 0;
}

/**
	Open a eks program file, or one together with a folder
	
	@param filename
		the path to the eks file
	@returns
		1 if it exited successfully.
*/
int haed_open_filetype_eks_program(char *filename)
{
	EksParent *gameEksParent=eks_parent_parse_file(filename);
			
	//load all units
	char *foldername=g_strndup(filename,strrchr(filename,'/')-filename);
	b_tm("test %s",foldername);

	char *imageDir=concat(foldername,"/img/",NULL);
	
	DIR *dir=opendir(imageDir);
	
	struct dirent *ent=NULL;

	if(dir != NULL) 
	{
		while ((ent = readdir (dir)) != NULL) 
		{
			if(strcmp(ent->d_name,"..")!=0 && strcmp(ent->d_name,".")!=0)
			{
				char *innerDir=concat(imageDir,ent->d_name,NULL);
				if(b_is_dir(innerDir))
				{
					char * buffer=NULL;
					char * buffer2=NULL;
					long length;
					
					char *eksLoc=concat(PROGRAM_DIR_IMG,ent->d_name,"/inf.eks",NULL);
					buffer=get_file_contents(eksLoc,NULL);
					free(eksLoc);
					
					char *imageLoc=concat(PROGRAM_DIR_IMG,ent->d_name,"/stopped.png",NULL);
					buffer2 = get_file_contents(imageLoc,&length);
					free(imageLoc);
					
					///AddEksParentGUI(ent->d_name,buffer2,length,buffer,ACTIVE_OBJECT_S);
					//b_tm("%s",ent->d_name);
				}
				free(innerDir);
			}
		}
	}
	
	haed_eks_set_objects_from_parent(gameEksParent);
	
	//later usage
	//GLOBAL_TRIGGER_PARENT=eks_parent_get_child_from_name(eks_parent_get_child(eks_parent_get_child_from_name(gameEksParent,"levels"),0),"triggers");
	haed_eks_set_triggers_from_parent(gameEksParent);
	
	return 1;
}

/**
	Cleans everything

	@param widget NO_FREE
		The widget you pressed
	@param input NO_FREE
		the input data
*/
void haed_clean_everything(GtkWidget *widget,gpointer data)
{
	GtkWidget *dialog;

	dialog = gtk_file_chooser_dialog_new (_("Open Project"),GTK_WINDOW(MAIN_WINDOW),GTK_FILE_CHOOSER_ACTION_OPEN,_("_Cancel"), GTK_RESPONSE_CANCEL,_("_Open"), GTK_RESPONSE_ACCEPT,NULL);

	if(gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
	{
		GLOBAL_CURRENT_FILE_NAME = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		
		char *extension=get_file_type(GLOBAL_CURRENT_FILE_NAME);
		
		b_tm("FileExtension=%s\n",extension);

		if(strcmp(extension,"hft")==0)
		{
			haed_open_filetype_hft(GLOBAL_CURRENT_FILE_NAME);
		}
		else if(strcmp(extension,"eks")==0)
		{
			haed_open_filetype_eks_program(GLOBAL_CURRENT_FILE_NAME);
		}
	}

	gtk_widget_destroy (dialog);

}

/**
	If someone presses the load game button.

	@param widget NO_FREE
		The widget you pressed
	@param input NO_FREE
		the input data
*/
void haed_load_program(GtkWidget *widget,gpointer data)
{
	GtkWidget *dialog;

	dialog = gtk_file_chooser_dialog_new (_("Open Project"),GTK_WINDOW(MAIN_WINDOW),GTK_FILE_CHOOSER_ACTION_OPEN,_("_Cancel"), GTK_RESPONSE_CANCEL,_("_Open"), GTK_RESPONSE_ACCEPT,NULL);

	if(gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
	{
		GLOBAL_CURRENT_FILE_NAME = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		
		char *extension=get_file_type(GLOBAL_CURRENT_FILE_NAME);
		
		b_tm("FileExtension=%s\n",extension);

		if(strcmp(extension,"hft")==0)
		{
			haed_open_filetype_hft(GLOBAL_CURRENT_FILE_NAME);
		}
		else if(strcmp(extension,"eks")==0)
		{
			haed_open_filetype_eks_program(GLOBAL_CURRENT_FILE_NAME);
		}
	}

	gtk_widget_destroy (dialog);

}

/**
	Save the program to a hft file. Saving to eks structure isnt supported yet.
	
	@todo
		change function name to like, haed_save_program_hft or haed_save_program(const char *file,HaedFileType filetype)?
	
	@param fileName
		the path to the file to be saved to
*/
void haed_save_program(char *fileName)
{
	char *textHaedTextFile=NULL;
	EksParent *GameEksParent;
	
	printf("Will now save the game...\n");
	
	//do not compress, want all unit info :P
	GameEksParent=HAED_GLOBAL_INFORMATION.firstProgram->program;
	
	printf("GOT TO THE END\n");
	
	textHaedTextFile=eks_parent_dump_text(GameEksParent);
	
	printf("%s\n",textHaedTextFile);
	
	b_tm("WILL NOW SAVE THE FILE!\n");
	
	struct zip *z;
	struct zip_source *s; 
	//const char buf="teststring"; 
	 
	z=zip_open(fileName,ZIP_CREATE,NULL);
	
	if((s=zip_source_buffer(z, textHaedTextFile, strlen(textHaedTextFile), 0)) == NULL || zip_add(z, "program.eks", s) < 0) 
	{ 
		zip_source_free(s); 
		b_error_message("Could not add file: %s\n", zip_strerror(z)); 
	}
	
	char *buffer=NULL;
	gsize buflength=0;
	
	EksParent *objectP=eks_parent_get_child_from_name(GameEksParent,"objects");
	EksParent *activeP=eks_parent_get_child_from_name(objectP,"active");
	
	eks_parent_foreach_child_start(activeP,object)
	{
		EksParent *objbuffholder=eks_parent_custom_get(object,HAED_OBJECT_BUFFHOLDER);
		
		eks_parent_foreach_child_start(objbuffholder,curBuf)
		{
			char *animationstr=eks_parent_get_string(curBuf);
		
			if(eks_parent_compare_type(curBuf,EKS_PARENT_TYPE_VALUE) && haed_animations_is_animation(animationstr))
			{
				gdk_pixbuf_save_to_buffer(eks_parent_custom_get(curBuf,0),&buffer,&buflength,"png",NULL,NULL);
				char *pngfilename=concat("img/",object->name,"/",animationstr,".png",NULL);
			
				if((s=zip_source_buffer(z, buffer, buflength, 0)) == NULL || zip_add(z, pngfilename, s) < 0) 
				{ 
					zip_source_free(s); 
					b_error_message("Could not add file: %s\n", zip_strerror(z)); 
				}
			
				free(pngfilename);
			}
			
			free(animationstr);
		}eks_parent_foreach_child_end(objbuffholder,curBuf);
		
		char *buffer2=eks_parent_dump_text(objbuffholder);
		
		b_tm("buffer2 %s\n",buffer2);
		
		char *inffilename=concat("img/",object->name,"/inf.eks",NULL);
		
		if((s=zip_source_buffer(z, buffer2, strlen(buffer2), 0)) == NULL || zip_add(z, inffilename, s) < 0) 
		{ 
			zip_source_free(s); 
			b_error_message("Could not add file: %s\n", zip_strerror(z)); 
		}
		
		free(inffilename);
	}eks_parent_foreach_child_end(activeP,object);
	
	//b_tm("%s\n",buffer);
	
	zip_close(z);

	b_tm("KLART!");
	/*
	if(textHaedTextFile!=NULL)
	{
		SaveFile("./../hattis/program.haed",textHaedTextFile);
	}
	else
	{
		printf("ERROR: Failed to save file!");
	}
	*/
}

/**
	Save as dialog window.
	
	@todo
		move this to dialog functions?
		
	@param widget
		widget from
	@param data
		some input data
*/
void haed_gui_save_as(GtkWidget *widget,gpointer data)
{
	GtkWidget *dialog;

	dialog = gtk_file_chooser_dialog_new (_("Save as"),GTK_WINDOW(MAIN_WINDOW),GTK_FILE_CHOOSER_ACTION_SAVE,_("_Cancel"), GTK_RESPONSE_CANCEL,_("_Save"), GTK_RESPONSE_ACCEPT,NULL);

	if(gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
	{
		GLOBAL_CURRENT_FILE_NAME = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		
		b_tm("WILL SAVE TO: %s\n",GLOBAL_CURRENT_FILE_NAME);
		
		haed_save_program(GLOBAL_CURRENT_FILE_NAME);
	}

	gtk_widget_destroy (dialog);
}

/**
	only save from the current instance

	@param widget
		widget from
	@param data
		some input data
*/
void haed_gui_save(GtkWidget *widget,gpointer data)
{
	if(GLOBAL_CURRENT_FILE_NAME)
	{
		//haed_save_program(GLOBAL_CURRENT_FILE_NAME);
	}
	else
	{
		haed_gui_save_as(widget,data);
	}
}

/**
	If someone presses the run level button
	
	@param widget
		the input widget
	@param data
		the input data
		probably nothing
*/
void haed_run(GtkWidget *widget,gpointer data)
{
	char *makecommand;
	EksParent *GameEksParent;
	
	b_debug_message("Will now generate the game...\n");
	
	GameEksParent=HAED_GLOBAL_INFORMATION.firstProgram->program;//haed_eks_generate_program_parent(0);
	
	printf("GOT TO THE END \n===\n%s\n===\n",eks_parent_dump_text(GameEksParent));
	
	EksParent *runProgramOrLevel;
	
	if(data==NULL)
	{
		runProgramOrLevel=NULL;
		makecommand="cd ./../pgd/ && make run";
	}
	else
	{
		runProgramOrLevel=haed_programinfo_get_current_level(GameEksParent);
		makecommand="cd ./../pgd/ && make run RUN_LEVEL=-DRUN_LEVEL";
	}
	
	char *GeneratedFile=generateCProgramFile(GameEksParent,runProgramOrLevel);
	
	if(GeneratedFile!=NULL)
	{
		EksParent *objectP=eks_parent_get_child_from_name(GameEksParent,"objects");
		EksParent *activeP=eks_parent_get_child_from_name(objectP,"active");
		
		eks_parent_foreach_child_start(activeP,object)
		{
			if(eks_parent_compare_type(object,EKS_PARENT_TYPE_VALUE))
			{
				EksParent *objbuffholder=eks_parent_custom_get(object,HAED_OBJECT_BUFFHOLDER);
			
				eks_parent_foreach_child_start(objbuffholder,animationParent)
				{
					char *animationstr=eks_parent_get_string(animationParent);
					
					if(eks_parent_compare_type(animationParent,EKS_PARENT_TYPE_VALUE) && haed_animations_is_animation(animationstr))
					{
						char *buffer=NULL;
						gsize buflength=0;

						b_tm("RUNLEVEL GENERATE IMG");
				
						b_tm("ANIMATIONSTR %s",animationstr);
				
						gdk_pixbuf_save_to_buffer(eks_parent_custom_get(animationParent,0),&buffer,&buflength,"png",NULL,NULL);
				
						char *imgfilename=concat("./../pgd/img/",object->name,"/",animationstr,".png",NULL);
						//printf("name:%s,%s\n",imgfilename,buffer);
				
						char *mkdir=concat("cd ./../pgd/img && mkdir ",object->name,NULL);
						printf("%s %s\n",mkdir,imgfilename);
						system(mkdir);
						free(mkdir);
				
						SaveFile_tl(imgfilename,buffer,buflength);
				
						free(imgfilename);
						free(buffer);
					}
					
					free(animationstr);
				}eks_parent_foreach_child_end(objbuffholder,animationParent);
			}
		}eks_parent_foreach_child_end(activeP,object);
		
		
		SaveFile("./../pgd/program.c",GeneratedFile);
		
		system(makecommand);
	}
	else
	{
		b_error_message("Failed to create file!");
	}
	//printf("%s\n",GeneratedFile);
}
